//---------------------------------------------------------
// FracNEON_sp_opt1 *text only* Benchmark by Michael Kübel 
//---------------------------------------------------------

#include <iostream>
#include <iomanip>
#include <cstdint>
#include <chrono>
#include <cstring>
#define WINDOW_WIDTH 600

using namespace std;

extern "C" uint64_t CalcMandelbrotASM_FracNEON_sp_opt1(const uint32_t* p);

int main(int argc, char** argv)
{
    uint32_t *pixels = new uint32_t[WINDOW_WIDTH*WINDOW_WIDTH];
    memset(pixels,0,WINDOW_WIDTH*WINDOW_WIDTH*sizeof(uint32_t));

    cout<<"FracNEON_sp_opt1 V1.0 by Michael Kübel\n";
    cout<<"--------------------------------------\n";
    cout<<"Calculating a Mandelbrot of 600x600 pixels at 4096 iterations and looping 10 times\n";
    cout<<"Start...\n";

    auto start = std::chrono::system_clock::now();
    uint64_t global_iterations = CalcMandelbrotASM_FracNEON_sp_opt1(pixels);
    auto end = std::chrono::system_clock::now();
    chrono::duration <double> secondsElapsed = end-start;

    cout<<"Done...\n";
    cout<<"Iterations.: "<<global_iterations<<"\n";
    cout<<"Time taken.: "<<fixed<<setprecision(3)<<secondsElapsed.count()<<" s\n";
    cout<<"Speed......: "<<fixed<<setprecision(3)<<(global_iterations/secondsElapsed.count()/1000000)<<" Million Iterations/s\n";

    delete[] pixels;
    return 0;
}
